Index: asterisk/apps/app_dial.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_dial.c,v
retrieving revision 1.144
diff -u -r1.144 app_dial.c
--- asterisk/apps/app_dial.c	1 Apr 2005 17:00:50 -0000	1.144
+++ asterisk/apps/app_dial.c	8 Apr 2005 22:07:24 -0000
@@ -94,6 +94,8 @@
 "      'S(x)' -- hangup the call after x seconds AFTER called party picked up\n"  	
 "      'D([digits])'  -- Send DTMF digit string *after* called party has answered\n"
 "             but before the bridge. (w=500ms sec pause)\n"
+"      'I([digits])'  -- Does what D() does, but sends the DTMF to the calling party instead.\n"
+"             Useful for sending call progress tones (e.g. ABCD)\n" 		
 "      'L(x[:y][:z])' -- Limit the call to 'x' ms warning when 'y' ms are left\n"
 "             repeated every 'z' ms) Only 'x' is required, 'y' and 'z' are optional.\n"
 "             The following special variables are optional:\n"
@@ -627,6 +629,7 @@
 	char limitdata[256];
 	char *sdtmfptr;
 	char sdtmfdata[256] = "";
+	char cdtmfdata[256] = "";
 	char *stack,*var;
 	char *mac = NULL, *macroname = NULL;
 	char status[256]="";
@@ -694,7 +697,7 @@
 				ast_verbose(VERBOSE_PREFIX_3 "Setting call duration limit to %i seconds.\n",calldurationlimit);			
 		} 
 
-		/* DTMF SCRIPT*/
+		/* DTMF SCRIPT for the D() option*/
 		if ((sdtmfptr = strstr(transfer, "D("))) {
 			strncpy(sdtmfdata, sdtmfptr + 2, sizeof(sdtmfdata) - 1);
 			/* Overwrite with X's what was the sdtmf info */
@@ -709,7 +712,24 @@
 			else 
 				ast_log(LOG_WARNING, "D( Data lacking trailing ')'\n");
 		}
-		
+  
+                /* DTMF SCRIPT for the I() option*/
+                if ((sdtmfptr = strstr(transfer, "I("))) {
+                        strncpy(cdtmfdata, sdtmfptr + 2, sizeof(cdtmfdata) - 1);
+                        /* Overwrite with X's what was the sdtmf info */
+                        while (*sdtmfptr && (*sdtmfptr != ')'))
+                        	*(sdtmfptr++) = 'X';
+                        if (*sdtmfptr)
+				*sdtmfptr = 'X';
+			/* Now find the end  */
+                        sdtmfptr = strchr(cdtmfdata, ')');
+                        if (sdtmfptr)
+                                *sdtmfptr = '\0';
+                         else
+                                ast_log(LOG_WARNING, "I( Data lacking trailing ')'\n");
+                }
+  	
+
 		/* XXX LIMIT SUPPORT */
 		if ((limitptr = strstr(transfer, "L("))) {
 			strncpy(limitdata, limitptr + 2, sizeof(limitdata) - 1);
@@ -1257,6 +1277,8 @@
 			}
 			if (!ast_strlen_zero(sdtmfdata)) 
 				res = ast_dtmf_stream(peer,chan,sdtmfdata,250);
+			if (!ast_strlen_zero(cdtmfdata))
+                                res = ast_dtmf_stream(chan,peer,cdtmfdata,250);	
 		}
 		
 		if (!res) {
